<?php

namespace App\DataTables;

use App\Models\BoltWithNutsInch;
use App\Models\LengthInch;
use App\Models\DiameterInch;
use Illuminate\Database\Eloquent\Builder as QueryBuilder;
use Yajra\DataTables\EloquentDataTable;
use Yajra\DataTables\Html\Builder as HtmlBuilder;
use Yajra\DataTables\Html\Button;
use Yajra\DataTables\Html\Column;
use Yajra\DataTables\Html\Editor\Editor;
use Yajra\DataTables\Html\Editor\Fields;
use Yajra\DataTables\Services\DataTable;

class BoltWithNutsInchDataTable extends DataTable
{
    /**
     * Build the DataTable class.
     *
     * @param QueryBuilder<BoltWithNutsInch> $query Results from query() method.
     */
    public function dataTable(QueryBuilder $query): EloquentDataTable
    {
        return (new EloquentDataTable($query))
        ->editColumn('length', function ($query) {
            return LengthInch::where('id','=',$query->length)->pluck('name')->first();
        })
        ->addColumn('dimeter', function ($query) {
            return DiameterInch::where('id','=',$query->diameter)->pluck('name')->first();
        })
        ->addColumn('action', function($query){
            // view Button
            $viewButton = "";
            // if(auth()->user()->can('client_code_view')){
                // $viewButton = "<a class='view btn btn-secondary btn-sm' data-id='".$query->id."' data-toggle='modal' data-target='#exampleModal'><i class='fas fa-eye'></i></a>";
                $viewButton = '<a href="'.route('admin/boltwithnuts/inch/show',$query->id).'" class="btn btn-info btn-sm"><i class="lni lni-eye"></i></a>';
            // }
            // Update Button
            $updateButton = "";
            // if(auth()->user()->can('client_code_edit')){
                $updateButton = '<a href="'.route('admin/boltwithnuts/inch/edit',$query->id).'" class="btn btn-info btn-sm"><i class="lni lni-pencil-alt"></i></a>';
            // }
            // Delete Button
            $deleteButton = "";
            // if(auth()->user()->can('client_code_delete')){
                $deleteButton = "<a class='delete btn btn-danger btn-sm' title='Delete' data-toggle='tooltip' data-id='".$query->id."'><i class='lni lni-trash'></i></a>";
            // }
            return $viewButton." ".$updateButton." ".$deleteButton;
        })
        ->rawColumns(['length','dimeter','action']);
    }

    /**
     * Get the query source of dataTable.
     *
     * @return QueryBuilder<BoltWithNutsInch>
     */
    public function query(BoltWithNutsInch $model): QueryBuilder
    {
        return $model->newQuery()->orderbyDesc('id');
    }

    /**
     * Optional method if you want to use the html builder.
     */
    public function html(): HtmlBuilder
    {
        return $this->builder()
                    ->setTableId('boltwithnutsinch-table')
                    ->columns($this->getColumns())
                    ->minifiedAjax()
                    ->orderBy(1)
                    ->selectStyleSingle()
                    ->buttons([
                        // Button::make('excel'),
                        // Button::make('csv'),
                        // Button::make('pdf'),
                        // Button::make('print'),
                        // Button::make('reset'),
                        // Button::make('reload')
                    ]);
    }

    /**
     * Get the dataTable columns definition.
     */
    public function getColumns(): array
    {
        return [
            'length' => ['data' => 'length', 'name' => 'length', 'title' => 'Length'],
            'dimeter' => ['data' => 'dimeter', 'name' => 'dimeter', 'title' => 'Dimeter'],
            'value' => ['data' => 'value', 'name' => 'value', 'title' => 'Value'],
            Column::computed('action')
                  ->exportable(false)
                  ->printable(false)
                  ->width(120)
                  ->addClass('text-center'),
            // Column::make('id'),
            // Column::make('add your columns'),
            // Column::make('created_at'),
            // Column::make('updated_at'),
        ];
    }

    /**
     * Get the filename for export.
     */
    protected function filename(): string
    {
        return 'BoltWithNutsInch_' . date('YmdHis');
    }
}
